;*************************************************************************
;OpenPCX
;	takes zpstr name of file in a string named varstr
;	takes pointer to buffer in btemp -assumes memory is allocated
;		(use fs as the selector)
;	-save destination beginning (initial btemp) before calling
;		-use [buffer]
;	returns xres and yres
OpenPCX proc

		mov al,R
		mov esi,offset varstr
		call fopen	;open file
		mov [temp],ax	;temp is the file handle

		mov bx,[temp]
		mov cx,128
		call fread

		push es
		mov bx,cs:[6]
		mov es,bx

		;find resolution
;hdr.BytesPerLine * hdr.Nplanes * (1 + hdr.Ymax - hdr.Ymin)
		mov ax,es:[66]	;BytesPerLine
		xor bx,bx
		mov bl,es:[65]	;Nplanes
		mov [xres],ax	;store # of bytes per line
		mul bx
		shl edx,16
		mov dx,ax	;edx = BytesPerLine * Nplanes
		xor eax,eax
		mov ax,1	;1
		add ax,es:[10]	;Ymax
		sub ax,es:[6]	;Ymin
		mov [yres],ax	;store Y distance
		mov ebx,edx
		mul ebx		;eax has size
		mov [lsize],eax

		mov [l],0
	ForBegin:
		mov eax,[lsize]
		cmp [l],eax
		jae ForEnd

		call encget
		cmp [flag],1
		je ForEnd

		mov [i],0
		For2Begin:
			mov eax,[cnt]
			cmp [i],eax
			jae For2End

			mov al,[chr]
			mov edi,[btemp]
			mov fs:[edi],al
			inc [btemp]
			inc [i]
			jmp For2Begin
		For2End:

		mov eax,[cnt]
		add [l],eax
		jmp ForBegin
	ForEnd:



		mov bx,[temp]
		call fclose	;done with file
		pop es
	ret
ENDP


encget proc
	mov [cnt],1

	mov bx,[temp]
	mov cx,1
	call fread
	cmp ax,1
	jne EOFRet
	xor eax,eax
	mov al,es:[0]
	mov [i],eax

	and eax,0c0h
	cmp eax,0c0h
	jne NotIf
		mov eax,[i]
		mov bx,[temp]
		and eax,3fh
		mov cx,1
		mov [cnt],eax
		call fread
		cmp ax,1
		jne EOFRet
		xor eax,eax
		mov al,es:[0]
		mov [i],eax
	NotIf:

	mov eax,[i]
	mov [flag],0
	mov [chr],al

	ret

EOFRet:
	mov [flag],1
	ret
ENDP

ALIGN	8
buffer	dd	(?)
btemp	dd	(?)
l	dd	(?)
i	dd	(?)
lsize	dd	(?)
cnt	dd	(?)
xres	dw	(?)
yres	dw	(?)
chr	db	(?)
flag	db	(?)